<template>
    <section class="settings_main">
        <div class="p-3 w-100">
            <div class="settings_content_inr base_block">

                <div class="p-3 dav_settings_panel dav_df justify-content-between">
                    <h6 class="dav_call_center_h6">
                        {{ $store.state.locale.callCenter }}
                    </h6>
                    <button type="button" class="login_main_sign_btn" style="background: #1bd271;" @click="getXml()"
                            v-if="can('settings_call_center', 'Edit')">Apply
                    </button>
                </div>

                <div class="settings_panel p-3 dav_settings_panel">
                    <div class="settings_panel_ttl">
                        <div class="txt">{{ $store.state.locale.queues }}</div>
                        <button
                                type="button"
                                class="login_main_sign_btn bt"
                                data-toggle="modal"
                                data-target="#add_queues"
                                @click="clearQueueForm()"
                                v-if="can('settings_call_center', 'Edit')"
                        >
                            {{ $store.state.locale.addQueues }}
                        </button>
                    </div>
                    <div class="settings_panel_cnt">
                        <div class="table-responsive settings_content_tb">
                            <table class="table table-striped table-hover">
                                <thead>
                                <tr>
                                    <th scope="col">Id</th>
                                    <th scope="col">{{ $store.state.locale.queueName }}</th>
                                    <th scope="col">{{ $store.state.locale.strategy }}</th>
                                    <th scope="col">{{ $store.state.locale.tierRule }}</th>
                                    <th scope="col">{{ $store.state.locale.maxWaitTime }}</th>
                                    <th scope="col">{{ $store.state.locale.maxWaitNoAgent }}</th>
                                    <th scope="col" class="w-40" v-if="can('settings_call_center', 'Edit')"></th>
                                </tr>
                                </thead>
                                <tbody>
                                <tr v-for="queue in allQueues">
                                    <td>{{queue.id}}</td>
                                    <td>{{queue.name}}</td>
                                    <td>{{queue.strategy}}</td>
                                    <td>{{queue.tierRuleWaitSecond}}</td>
                                    <td>{{queue.maxWaitTime}}</td>
                                    <td>{{queue.maxWaitTimeWithNoAgent}}</td>
                                    <td v-if="can('settings_call_center', 'Edit')">
                                        <div class="btn-group">
                                            <button type="button" class="icon-btn" @click="queueSendFormType(queue)">
                                                <i class="mdi mdi-pencil"></i>
                                            </button>
                                            <button type="button" class="icon-btn" @click="deleteQueue(queue.id)">
                                                <i class="mdi mdi-delete text-danger"></i>
                                            </button>
                                        </div>
                                    </td>
                                </tr>
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>

                <div class="settings_panel p-3">
                    <div class="settings_panel_ttl">
                        <div class="txt">{{ $store.state.locale.agent }}</div>
                        <button
                                type="button"
                                class="login_main_sign_btn bt"
                                data-toggle="modal"
                                data-target="#s_c_c_add_agents"
                                @click="clearAgentForm()"
                                v-if="can('settings_call_center', 'Edit')"
                        >
                            {{ $store.state.locale.addAgent }}
                        </button>
                    </div>
                    <div class="settings_panel_cnt">
                        <div class="table-responsive settings_content_tb">
                            <table class="table table-striped table-hover">
                                <thead>
                                <tr>
                                    <th scope="col">Id</th>
                                    <th scope="col">{{ $store.state.locale.agentName }}</th>
                                    <th scope="col">{{ $store.state.locale.type }}</th>
                                    <th scope="col">{{ $store.state.locale.status }}</th>
                                    <th scope="col">{{ $store.state.locale.maxNoAnswer }}</th>
                                    <th scope="col">{{ $store.state.locale.wrapUpTime }}</th>
                                    <th scope="col">{{ $store.state.locale.rejectDelayTime }}</th>
                                    <th scope="col">{{ $store.state.locale.busyDelayTime}}</th>
                                    <th scope="col" class="w-40" v-if="can('settings_call_center', 'Edit')"></th>
                                </tr>
                                </thead>
                                <tbody>
                                <tr v-for="agent in allAgents">
                                    <td>{{agent.id}}</td>
                                    <td>{{agent.name}}</td>
                                    <td>{{agent.type}}</td>
                                    <td>{{agent.status}}</td>
                                    <td>{{agent.maxNoAnswer}}</td>
                                    <td>{{agent.wrapUpTime}}</td>
                                    <td>{{agent.rejectDelayTime}}</td>
                                    <td>{{agent.busyDelayTime}}</td>
                                    <td v-if="can('settings_call_center', 'Edit')">
                                        <div class="btn-group">
                                            <button type="button" class="icon-btn" @click="agentSendFormType(agent)">
                                                <i class="mdi mdi-pencil"></i>
                                            </button>
                                            <button type="button" class="icon-btn" @click="deleteAgent(agent.id)">
                                                <i class="mdi mdi-delete text-danger"></i>
                                            </button>
                                        </div>
                                    </td>
                                </tr>
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>

                <div class="settings_panel p-3">
                    <div class="settings_panel_ttl">
                        <div class="txt">{{ $store.state.locale.tiers }}</div>
                        <button
                                type="button"
                                class="login_main_sign_btn bt"
                                data-toggle="modal"
                                data-target="#s_c_c_add_tier"
                                @click="clearTierForm()"
                                v-if="can('settings_call_center', 'Edit')"
                        >
                            {{ $store.state.locale.addtier}}
                        </button>
                    </div>
                    <div class="settings_panel_cnt">
                        <div class="table-responsive settings_content_tb">
                            <table class="table table-striped table-hover">
                                <thead>
                                <tr>
                                    <th scope="col">Id</th>
                                    <th scope="col">{{ $store.state.locale.agent }}</th>
                                    <th scope="col">{{ $store.state.locale.queues }}</th>
                                    <th scope="col">{{ $store.state.locale.level }}</th>
                                    <th scope="col">{{ $store.state.locale.position }}</th>
                                    <th scope="col" class="w-40" v-if="can('settings_call_center', 'Edit')"></th>
                                </tr>
                                </thead>
                                <tbody>
                                <tr v-for="tier in allTiers">
                                    <td>{{tier.id}}</td>
                                    <td>{{tier.agent}}</td>
                                    <td>{{tier.queue}}</td>
                                    <td>{{tier.level}}</td>
                                    <td>{{tier.position}}</td>
                                    <td v-if="can('settings_call_center', 'Edit')">
                                        <div class="btn-group">
                                            <button type="button" class="icon-btn" @click="tierSendFormType(tier)">
                                                <i class="mdi mdi-pencil"></i>
                                            </button>
                                            <button type="button" class="icon-btn" @click="deleteTier(tier.id)">
                                                <i class="mdi mdi-delete text-danger"></i>
                                            </button>
                                        </div>
                                    </td>
                                </tr>
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>

                <!--<div class="p-3 dav_df justify-content-end">-->
                <!--<nav aria-label="...">-->
                <!--<ul class="pagination">-->
                <!--<li class="page-item disabled">-->
                <!--<a class="page-link" href="#" tabindex="-1" aria-disabled="true">Previous</a>-->
                <!--</li>-->
                <!--<li class="page-item"><a class="page-link" href="#">1</a></li>-->
                <!--<li class="page-item active" aria-current="page">-->
                <!--<a class="page-link" href="#">2 <span class="sr-only">(current)</span></a>-->
                <!--</li>-->
                <!--<li class="page-item"><a class="page-link" href="#">3</a></li>-->
                <!--<li class="page-item">-->
                <!--<a class="page-link" href="#">Next</a>-->
                <!--</li>-->
                <!--</ul>-->
                <!--</nav>-->
                <!--</div>-->
            </div>


            <div class="modal fade" id="add_queues" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
                 aria-hidden="true">
                <div class="modal-dialog modal-lg" role="document">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title d-flex justify-content-center w-100" id="add_queues_m_h">
                                {{queueForm.id > 0 ? $store.state.locale.editQueues : $store.state.locale.addQueues }}</h5>
                        </div>
                        <div class="modal-body">
                            <form @submit.prevent="queueSendForm">
                                <div class="row">
                                    <div class="col-lg-6">
                                        <div class="form-group">
                                            <label for="queue_name" class="col-form-label">
                                                {{ $store.state.locale.name }}
                                                <span class="dav_help_circle">
											    <i class="mdi mdi-help-circle" :title="$store.state.locale.nameTitle"></i>
										    </span>
                                            </label>
                                            <input type="text" class="form-control" id="queue_name"
                                                   v-model="queueForm.name" required>
                                        </div>

                                        <div class="form-group">
                                            <label for="add_queue_strategy" class="col-form-label">
                                                {{ $store.state.locale.strategy }}
                                                <span class="dav_help_circle">
											    <i class="mdi mdi-help-circle"
                                                   :title="$store.state.locale.strategyTitle"></i>
										    </span>
                                            </label>
                                            <select name="" id="add_queue_strategy" class="form-control"
                                                    v-model="queueForm.strategy">
                                                <option value="" selected disabled hidden>{{ $store.state.locale.select }}</option>
                                                <option value="ring-all">{{ $store.state.locale.ring_all }}</option>
                                                <option value="longest-idle-agent">{{ $store.state.locale.longest_idle_agent }}</option>
                                                <option value="round-robin">{{ $store.state.locale.round_robin }}</option>
                                                <option value="top-down">{{ $store.state.locale.top_down }}</option>
                                                <option value="agent-with-least-talk-time">{{ $store.state.locale.agent_with_least_talk_time }}
                                                </option>
                                                <option value="agent-with-fewest-calls">{{ $store.state.locale.agent_with_fewest_calls }}</option>
                                                <option value="sequentially-by-agent-order">
                                                    {{ $store.state.locale.sequentially_by_agent_order }}
                                                </option>
                                                <option value="random">{{ $store.state.locale.random }}</option>
                                                <option value="ring-progressively">{{ $store.state.locale.ring_progressively }}</option>
                                            </select>
                                        </div>

                                        <div class="form-group">
                                            <label for="add_queue_melody_o_h" class="col-form-label">
                                                {{ $store.state.locale.melody }}
                                            </label>
                                            <!--<select name="" id="add_queue_melody_o_h" class="form-control" v-model="queueForm.mohSound">-->
                                            <!--<option value="menu-exec-app"></option>-->
                                            <!--<option value="menu-sub">Menu sub</option>-->
                                            <!--<option value="menu-top">Menu top</option>-->
                                            <!--<option value="menu-play-sound">Menu play sound</option>-->
                                            <!--</select>-->
                                            <input type="text" class="form-control" id="add_queue_melody_o_h"
                                                   v-model="queueForm.mohSound">
                                        </div>

                                        <div class="form-group">
                                            <label for="record_template" class="col-form-label">
                                                {{ $store.state.locale.recordTemplate }}
                                                <span class="dav_help_circle">
											    <i class="mdi mdi-help-circle"
                                                   :title="$store.state.locale.recordTemplateTitle "></i>
										    </span>
                                            </label>
                                            <input type="text" class="form-control" id="record_template"
                                                   v-model="queueForm.recordTemplate">
                                        </div>

                                        <div class="form-group">
                                            <label for="time_b_s" class="col-form-label">
                                                {{ $store.state.locale.timeBaseScore }}
                                            </label>
                                            <input type="text" class="form-control" id="time_b_s"
                                                   v-model="queueForm.timeBaseScore">
                                        </div>

                                        <div class="form-group">
                                            <label for="tier_r_a" class="col-form-label">
                                                {{ $store.state.locale.tierRulesApply }}
                                            </label>
                                            <select name="" id="tier_r_a" class="form-control"
                                                    v-model="queueForm.tierRulesApply">
                                                <option value="" selected disabled hidden>{{ $store.state.locale.select }}</option>
                                                <option value="true">True</option>
                                                <option value="false">False</option>
                                            </select>
                                        </div>

                                        <div class="form-group">
                                            <label for="tier_r_w_a" class="col-form-label">
                                                {{ $store.state.locale.tierRuleWaitSecond }}
                                            </label>
                                            <input type="text" class="form-control" id="tier_r_w_a"
                                                   v-model="queueForm.tierRuleWaitSecond">
                                        </div>
                                    </div>


                                    <div class="col-lg-6">
                                        <div class="form-group">
                                            <label for="tier_level" class="col-form-label">
                                                {{ $store.state.locale.tierRuleWaitMultiplyLevel }}
                                            </label>
                                            <select name="" id="tier_level" class="form-control"
                                                    v-model="queueForm.tierRuleWaitMultiplyLevel">
                                                <option value="" selected disabled hidden>{{ $store.state.locale.select }}</option>
                                                <option value="true">True</option>
                                                <option value="false">False</option>
                                            </select>
                                        </div>

                                        <div class="form-group">
                                            <label for="tier_r_n_a" class="col-form-label">
                                                {{ $store.state.locale.tierRuleNoAgentNoWait }}
                                                <span class="dav_help_circle">
											    <i class="mdi mdi-help-circle"
                                                   :title="$store.state.locale.tierRuleNoAgentNoWaitTitle "></i>
										    </span>
                                            </label>
                                            <select name="" id="tier_r_n_a" class="form-control"
                                                    v-model="queueForm.tierRuleNoAgentNoWait">
                                                <option value="" selected disabled hidden>{{ $store.state.locale.select }}</option>
                                                <option value="true">True</option>
                                                <option value="false">False</option>
                                            </select>
                                        </div>

                                        <div class="form-group">
                                            <label for="discard_a_a" class="col-form-label">
                                                {{ $store.state.locale.discardAbandonedAfter }}
                                                <span class="dav_help_circle">
											    <i class="mdi mdi-help-circle"
                                                   :title="$store.state.locale.discardAbandonedAfterTitle"></i>
										    </span>
                                            </label>
                                            <input type="text" class="form-control" id="discard_a_a"
                                                   v-model="queueForm.discardAbandonedAfter">
                                        </div>

                                        <div class="form-group">
                                            <label for="abandoned_r_a" class="col-form-label">
                                                {{ $store.state.locale.abandonedResumeAllowed }}
                                                <span class="dav_help_circle">
											    <i class="mdi mdi-help-circle"
                                                   :title="$store.state.locale.abandonedResumeAllowedTitle"></i>
										    </span>
                                            </label>
                                            <select name="" id="abandoned_r_a" class="form-control"
                                                    v-model="queueForm.abandonedResumeAllowed">
                                                <option value="" selected disabled hidden>{{ $store.state.locale.select }}</option>
                                                <option value="true">True</option>
                                                <option value="false">False</option>
                                            </select>
                                        </div>

                                        <div class="form-group">
                                            <label for="max_w_t" class="col-form-label">
                                                {{ $store.state.locale.maxWaitTime }}
                                                <span class="dav_help_circle">
											    <i class="mdi mdi-help-circle"
                                                   :title="$store.state.locale.maxWaitTimeTitle"></i>
										    </span>
                                            </label>
                                            <input type="text" class="form-control" id="max_w_t"
                                                   v-model="queueForm.maxWaitTime">
                                        </div>

                                        <div class="form-group">
                                            <label for="time_w_t_w" class="col-form-label">
                                                {{ $store.state.locale.maxWaitNoAgent }}
                                            </label>
                                            <input type="text" class="form-control" id="time_w_t_w"
                                                   v-model="queueForm.maxWaitTimeWithNoAgent">
                                        </div>
                                    </div>


                                    <div class="col-lg-12 dav_text_a_c">
                                        <button type="submit" class="fn_btn btn_fn_success mt-3 w-50">{{queueForm.id > 0
                                            ? 'Edit' : 'Add'}}
                                        </button>
                                    </div>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
            </div>

            <div class="modal fade" id="s_c_c_add_agents" tabindex="-1" role="dialog"
                 aria-labelledby="exampleModalLabel" aria-hidden="true">
                <div class="modal-dialog modal-lg" role="document">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title d-flex justify-content-center w-100" id="add_agent_m_h">
                                {{agentForm.id > 0 ? 'Edit' : 'Add'}} agent</h5>
                        </div>
                        <div class="modal-body">
                            <form @submit.prevent="agentSendForm">
                                <div class="row">
                                    <div class="col-lg-6">
                                        <div class="form-group">
                                            <label for="s_c_c_agent_name" class="col-form-label">
                                                {{ $store.state.locale.name }}
                                                <span class="dav_help_circle">
											    <i class="mdi mdi-help-circle" title="Имя агента"></i>
										    </span>
                                            </label>
                                            <input type="text" class="form-control" id="s_c_c_agent_name"
                                                   v-model="agentForm.name" required>
                                        </div>

                                        <div class="form-group">
                                            <label for="s_c_c_type" class="col-form-label">
                                                {{ $store.state.locale.type }}
                                                <span class="dav_help_circle">
											    <i class="mdi mdi-help-circle"
                                                   :title="$store.state.locale.typeTitle"></i>
										    </span>
                                            </label>
                                            <select name="" id="s_c_c_type" class="form-control"
                                                    v-model="agentForm.type">
                                                <option value="" selected disabled hidden>{{$store.state.locale.select}}</option>
                                                <option value="callback">{{$store.state.locale.callback}}</option>
                                                <option value="uuid-standby">{{$store.state.locale.uuid_standby}}</option>
                                            </select>
                                        </div>

                                        <div class="form-group">
                                            <label for="s_c_c_contact" class="col-form-label">
                                                {{$store.state.locale.contact}}
                                                <span class="dav_help_circle">
											    <i class="mdi mdi-help-circle"
                                                   :title="$store.state.locale.contactTitle"></i>
										    </span>
                                            </label>
                                            <input type="text" class="form-control" id="s_c_c_contact"
                                                   v-model="agentForm.contact">
                                        </div>

                                        <div class="form-group">
                                            <label for="s_C_c_status" class="col-form-label">
                                                {{$store.state.locale.status}}
                                                <span class="dav_help_circle">
											    <i class="mdi mdi-help-circle"
                                                   :title="$store.state.locale.agentStatusTitle"></i>
										    </span>
                                            </label>
                                            <select name="" id="s_C_c_status" class="form-control"
                                                    v-model="agentForm.status">
                                                <option value="" selected disabled hidden>{{$store.state.locale.select}}</option>
                                                <option value="Logged Out">{{$store.state.locale.loggedOut}}</option>
                                                <option value="Available">{{$store.state.locale.available}}</option>
                                                <option value="Available (On Demand)">{{$store.state.locale.availableOnDemand}}</option>
                                                <option value="On Break">{{$store.state.locale.onBreak}}</option>
                                            </select>
                                        </div>
                                    </div>


                                    <div class="col-lg-6">
                                        <div class="form-group">
                                            <label for="s_c_c_max_no_o" class="col-form-label">
                                                {{$store.state.locale.maxNoAnswer}}
                                                <span class="dav_help_circle">
											    <i class="mdi mdi-help-circle"
                                                   :title="$store.state.locale.maxNoAnswerTitle"></i>
										    </span>
                                            </label>
                                            <input type="text" class="form-control" id="s_c_c_max_no_o"
                                                   v-model="agentForm.maxNoAnswer">
                                        </div>

                                        <div class="form-group">
                                            <label for="s_c_c_wrap_up_t" class="col-form-label">
                                                {{$store.state.locale.wrapUpTime}}
                                                <span class="dav_help_circle">
											    <i class="mdi mdi-help-circle"
                                                   :title="$store.state.locale.wrapUpTimeTitle"></i>
										    </span>
                                            </label>
                                            <input type="text" class="form-control" id="s_c_c_wrap_up_t"
                                                   v-model="agentForm.wrapUpTime">
                                        </div>

                                        <div class="form-group">
                                            <label for="reject_d_t" class="col-form-label">
                                                {{$store.state.locale.rejectDelayTime}}
                                                <span class="dav_help_circle">
											    <i class="mdi mdi-help-circle"
                                                   :title="$store.state.locale.rejectDelayTimeTitle"></i>
										    </span>
                                            </label>
                                            <input type="text" class="form-control" id="reject_d_t"
                                                   v-model="agentForm.rejectDelayTime" required>
                                        </div>

                                        <div class="form-group">
                                            <label for="s_c_c_busy_d_t" class="col-form-label">
                                                {{$store.state.locale.busyDelayTime}}
                                                <span class="dav_help_circle">
											    <i class="mdi mdi-help-circle"
                                                   :title="$store.state.locale.busyDelayTimeTitle"></i>
										    </span>
                                            </label>
                                            <input type="text" class="form-control" id="s_c_c_busy_d_t"
                                                   v-model="agentForm.busyDelayTime">
                                        </div>
                                    </div>


                                    <div class="col-lg-12 dav_text_a_c">
                                        <button type="submit" class="fn_btn btn_fn_success mt-3 w-50">{{agentForm.id > 0
                                            ? 'Edit' : 'Add'}}
                                        </button>
                                    </div>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
            </div>

            <div class="modal fade" id="s_c_c_add_tier" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
                 aria-hidden="true">
                <div class="modal-dialog modal-lg" role="document">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title d-flex justify-content-center w-100">{{tierForm.id > 0 ? 'Edit' :
                                'Add'}} tier</h5>
                        </div>
                        <div class="modal-body">
                            <form @submit.prevent="tierSendForm">
                                <div class="row">
                                    <div class="col-lg-6">
                                        <div class="form-group">
                                            <label for="s_c_c_tier_agent" class="col-form-label">
                                                {{$store.state.locale.agent}}
                                            </label>
                                            <input type="text" class="form-control" id="s_c_c_tier_agent"
                                                   v-model="tierForm.agent" required>
                                        </div>

                                        <div class="form-group">
                                            <label for="s_c_c_queue" class="col-form-label">
                                                {{$store.state.locale.queues}}
                                            </label>
                                            <input type="text" class="form-control" id="s_c_c_queue"
                                                   v-model="tierForm.queue" required>
                                        </div>
                                    </div>


                                    <div class="col-lg-6">
                                        <div class="form-group">
                                            <label for="s_c_c_level" class="col-form-label">{{$store.state.locale.level}}</label>
                                            <!--<select name="" id="s_c_c_level" class="form-control" v-model="tierForm.level" required>-->
                                            <!--<option value="menu-exec-app"></option>-->
                                            <!--<option value="menu-sub">Menu sub</option>-->
                                            <!--<option value="menu-top">Menu top</option>-->
                                            <!--<option value="menu-play-sound">Menu play sound</option>-->
                                            <!--</select>-->
                                            <input type="text" class="form-control" id="s_c_c_level"
                                                   v-model="tierForm.level" required>
                                        </div>

                                        <div class="form-group">
                                            <label for="s_c_c_position" class="col-form-label">
                                                {{$store.state.locale.position}}
                                            </label>
                                            <input type="text" class="form-control" id="s_c_c_position"
                                                   v-model="tierForm.position">
                                        </div>
                                    </div>


                                    <div class="col-lg-12 dav_text_a_c">
                                        <button type="submit" class="fn_btn btn_fn_success mt-3 w-50">{{tierForm.id > 0
                                            ? 'Edit' : 'Add'}}
                                        </button>
                                    </div>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
            </div>

        </div>
    </section>
</template>


<script src="./script.js"></script>